#include "msl.hpp"

enum HeadLink
{
	head = 1,
	partner = 2,
	child = 3,
	other = 4,
};

int
main()
{
	namespace v = msl::var;
	msl::Population popul(100);
	std::ifstream in{ "survey.tsv" };
	assert(in.is_open());
	size_t head_index{};
	size_t previous_family{};
	size_t i{};
	while (true) {
		size_t family, head_link, birth_year, birth_month, birth_day;
		char gender;
		double x;
		in >> family >> head_link >> gender >> birth_year >> birth_month >> birth_day >> x;
		if (!in)
			break;
		// Is it the same family ?
		if (family != previous_family) {
			head_index = i;
			previous_family = family;
		}
		popul[i].create(msl::days_from_civil(birth_year, birth_month, birth_day), i + 1);
		popul[i].set_female(gender == 'F').set_x(x);
		// Nothing to do for the head of the family.
		if (head_link == HeadLink::head) {
		// For a partner, merge the two families and set the partner link.
		} else if (head_link == HeadLink::partner) {
			popul[head_index].merge_family(popul[i]);
			popul[i].set_partner(popul[head_index]);
			popul[head_index].set_partner(popul[i]);
		// For others, only merge the families.
		} else {
			popul[head_index].merge_family(popul[i]);
		}
		++i;
	}
	MSL_SHOW(popul.count_if(v::one))
	MSL_SHOW(popul.count_if(v::family_head))
	popul.save("my-population");
	return 0;
}
